//visual text comparer 
//by den po - jdp@bk.ru

//#define KOLIBRI

#ifdef KOLIBRI
	#define MEMSIZE 4096 * 60
	#include "../lib/io.h"
	#include "../lib/strings.h"
	#include "../lib/obj/console.h"
	#include "os_kolibri.h"
	IO io1, io2;
#else
	#include "os_win32.h"
#endif

#include "objects.h"

#define mincmpstrings 2
#define maxcmpstrings 10
#define maxcmpoffset  100

char* srcfilename;
char* dstfilename;
dword srcfile;
dword dstfile;
dword srcfilesize;
dword dstfilesize;
TCollection srcfilelines; //file lines
TCollection dstfilelines;
TCollection srcfilenums; //lines numbers
TCollection dstfilenums;

struct TSimpleCollection:TSortedCollection
{
  TSimpleCollection();
  int  Compare( int Key1, Key2 );
};
int TSimpleCollection::Compare( int Key1, Key2 ){
  return Key1-Key2;
}
TSimpleCollection::TSimpleCollection():TSortedCollection(1000,1000);
{
  comparemethod=#Compare;
}

TSimpleCollection diffs;   //list of differing strings
dword srcfilelinks;     //pointer to the previos line with the same first symbol
dword dstfilelinks;     //

getstrings(dword srcfile,srcfilesize,srcfilelines){
  ECX=srcfilesize;ESI=srcfile;
  WHILE(ECX){
	$push ECX,ESI
	EAX=srcfilelines; EAX.TCollection.Insert(ESI);
	$pop ESI,ECX
	WHILE(ECX){
	  $cld $lodsb ECX--;
	  if(AL==0x0D)||(AL==0x0A)DSBYTE[ESI-1]=0;
	  if(AL==0x0D)&&(DSBYTE[ESI]==0x0A){$lodsb;ECX--;}
	  if(AL==0x0D)||(AL==0x0A)BREAK;
	}
  }
}

#include "if.h"


main(){
	int i;
	int p;
	int bs,bd,bsc,bdc,bsp,bdp;
	int cache[256];
	char s1;
	int s2;

#ifdef KOLIBRI
	load_dll(libConsole, #con_init, 0);
	con_init stdcall (122, 40, 122, 800, "Hello");

	srcfilename= "1";
	dstfilename= "2";

	srcfile = io1.read(srcfilename);
	dstfile = io2.read(dstfilename);

	srcfilesize = io1.FILES_SIZE;
	dstfilesize = io2.FILES_SIZE;

	if (!srcfile) die("Srcfile file not found");
	if (!dstfile) die("Dstfile file not found");
#else
	srcfilename= "1";
	srcfile=-1;
	EBX=CreateFile(srcfilename,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0);
	if(EBX!=-1)
	{
		srcfilesize=GetFileSize(EBX,0);
		srcfile=GlobalAlloc(GMEM_FIXED,srcfilesize+1);
		if(!ReadFile(EBX,srcfile,srcfilesize,ESP,0))
		{
			GlobalFree(srcfile);
			srcfile=-1;
		} else {
			DSBYTE[srcfile+srcfilesize]=0;
		}
		CloseHandle(EBX);
	}
	if(srcfile!=-1) 
	{
		dstfilename= "2";
		dstfile=-1;
		EBX=CreateFile(dstfilename,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0);
		if(EBX!=-1)
		{
			dstfilesize=GetFileSize(EBX,0);
			dstfile=GlobalAlloc(GMEM_FIXED,dstfilesize+1);
			if(!ReadFile(EBX,dstfile,dstfilesize,ESP,0))
			{
				GlobalFree(dstfile);
				dstfile=-1;
			}else {
				DSBYTE[dstfile+dstfilesize]=0;
			}
			CloseHandle(EBX);
	  	}
		if(dstfile!=-1)
#endif
		{
			srcfilelines.TCollection(srcfilesize/40,8192);
			dstfilelines.TCollection(dstfilesize/40,8192);
			//fill line pointers
			getstrings(srcfile,srcfilesize,#srcfilelines);
			getstrings(dstfile,dstfilesize,#dstfilelines);
			srcfilenums.TCollection(srcfilelines.Count,1000);
			dstfilenums.TCollection(dstfilelines.Count,1000);

			srcfilelinks=GlobalAlloc(GMEM_FIXED,srcfilelines.Count*4);
			dstfilelinks=GlobalAlloc(GMEM_FIXED,dstfilelines.Count*4);

			//fill links on the next strings with the same first symbols
			FillMemory(#cache,sizeof(cache),-1); i=srcfilelines.Count;
			WHILE(i){
			  i--;
			  EBX=srcfilelines.At(i); EBX=DSBYTE[EBX];
			  DSDWORD[i<<2+srcfilelinks]=cache[EBX*4];
			  cache[EBX*4]=i;
			}
			FillMemory(#cache,sizeof(cache),-1); i=dstfilelines.Count;
			WHILE(i){
			  i--;
			  EBX=dstfilelines.At(i); EBX=DSBYTE[EBX];
			  DSDWORD[i<<2+dstfilelinks]=cache[EBX*4];
			  cache[EBX*4]=i;
			}

			diffs.TSimpleCollection();

			while( bsp < srcfilelines.Count ) || ( bdp < dstfilelines.Count )
			{
			  ////////////////////////////////////////////////////////
			  bsc=0;
			  p=dstfilelines.At(bdp);//current dst position
			  s1=DSBYTE[p];
			  bs=bsp+1;//found src line, bsc - number of matched
			  while( bs != -1 )//no next line starting with the same symbols
				 &&(bs-bsp<=maxcmpoffset)//check for 100 lines depth
				 &&(bs<srcfilelines.Count)
			  {
				s2=srcfilelines.At(bs);
				if(!lstrcmp(p,s2))
				{//line found
				  bsc=1;
				  WHILE(bsc<maxcmpstrings)//counting number of matching lines
					 &&(bdp+bsc<dstfilelines.Count)
					 &&(bs+bsc<srcfilelines.Count)
					 &&(!lstrcmp(dstfilelines.At(bdp+bsc),srcfilelines.At(bs+bsc)))bsc++;
				  BREAK;
				}
				if(DSBYTE[s2]==s1)bs=DSDWORD[bs<<2+srcfilelinks];else bs++;
			  }
			  bdc=0;
			  p=srcfilelines.At(bsp);//current src position
			  s1=DSBYTE[p];
			  bd=bdp+1;//found dst line, bsc - number of matched
			  while( bd != -1 )//no next line starting with the same symbols
				 &&(bd-bdp<=maxcmpoffset)//check for 100 lines depth
				 &&(bd<dstfilelines.Count)
			  {
				s2=dstfilelines.At(bd);
				if(!lstrcmp(p,s2))
				{
				  bdc=1;
				  WHILE(bdc<maxcmpstrings)//counting number of matching lines
					 &&(bsp+bdc<srcfilelines.Count)
					 &&(bd+bdc<dstfilelines.Count)
					 &&(!lstrcmp(srcfilelines.At(bsp+bdc),dstfilelines.At(bd+bdc)))bdc++;
				  BREAK;
				}
				if(DSBYTE[s2]==s1)bd=DSDWORD[bd<<2+dstfilelinks];else bd++;
			  }

			  if(bsc<bdc)
			   if(bd-bdp<bdc)
			   ||(bdc>=mincmpstrings)
			  {
				WHILE(bdp<bd){
				  diffs.Insert(srcfilenums.Count);
				  srcfilenums.Insert(-1); dstfilenums.Insert(bdp); bdp++;
				}
				continue;
			  }

			  if(lstrcmp(srcfilelines.At(bsp),dstfilelines.At(bdp)))diffs.Insert(srcfilenums.Count);
			  //lines are equal
			  srcfilenums.Insert(bsp); bsp++;
			  dstfilenums.Insert(bdp); bdp++;
			  CONTINUE;
			}

			GlobalFree(srcfilelinks);
			GlobalFree(dstfilelinks);

			if(!diffs.Count)printf("³nothin' to compare :)\n"); else ifinit();

			diffs.DeleteAll();        delete diffs;
			dstfilenums.DeleteAll();  delete dstfilenums;
			srcfilenums.DeleteAll();  delete srcfilenums;
			dstfilelines.DeleteAll(); delete dstfilelines;
			srcfilelines.DeleteAll(); delete srcfilelines;
			GlobalFree(dstfile);
			GlobalFree(srcfile);
	  	}
#ifndef KOLIBRI
	}
#endif
}
